# -*- coding: UTF-8 -*-

from common import logger


class Task(object):
    """ Заглушка для одиночной задачи """
    def __init__(self, result):
        self.result = result
        self.log = logger.getLogger('Service')

    def ready(self):
        """
        Возвращает статус готовности задачи.
        @return true 
        """
        return True

    def get(self):
        """
        Возвращает результат выполнения задачи.
        @return result результат
        """
        return self.result


class BasicTaskRunner(object):
    """
    Базовая реализация объекта выполняющего задачи
    Эта реализация выполняет функции непосредственно
    Используется в кассе
    """
    def __init__(self):
        pass
    
    def addAsyncTask(self, function, args):
        """
        Добавляет задачу на выполнение
        @param function функция которая будет выполнена
        @param args аргументы функции
        """
        return Task(function(*args))
     
    def stopAllTasks(self):
        """
        Остановка всех запущенных задач
        """
        pass
    
    def init(self, countOfTasks):
        """
        Инициализация
        @param countOfTasks количество параллельно выполняемых задач
        """
        pass
