# -*- coding: UTF-8 -*-

import multiprocessing
from common.basictaskrunner import BasicTaskRunner


class MprocTaskRunner(BasicTaskRunner):
    """
    Реализация объекта выполняющего задачи в пуле подпроцессов
    Используется на КС
    """
    def __init__(self):
        self.pool = None

    def addAsyncTask(self, function, args):
        return self.pool.apply_async(function, args)

    def stopAllTasks(self):
        if self.pool:
            try:
                self.pool.terminate()
            except:
                pass
            try:
                self.pool.close()
            except:
                pass
            self.pool.join()
    
    def init(self, countOfTasks):
        self.pool = multiprocessing.Pool(countOfTasks)
